<template>
  <div class="Test">
  <button  v-on:click="createCompanies()" >create</button>
  <button  v-on:click="pullCompanies()" >Show table</button>
  </div>
    <div class="Test">
    <br/>
    <br/>
    <br/>
    <table v-if="data.length">
        <thead>
            <tr>
                <th>ID</th>
                <th>Title</th>
                <th>Alt Title</th>
                <th>Source ID</th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="item in data" :key="item.id">
                <td>{{item.id}}</td>
                <td>{{item.title}}</td>
                <td>{{item.alttitle}}</td>
                <td>{{item.source_id}}</td>
                <td><button  v-on:click="deleteCompanies(item.id)" >Delete</button></td>
            </tr>
        </tbody>
    </table>
    </div>
</template>

<script>
//import { DataStore } from '@aws-amplify/datastore';
import {listCompaniess}  from "@/graphql/queries";
import {createCompanies, deleteCompanies}  from "@/graphql/mutations";
import { API } from "aws-amplify";

export default {
  name: 'Test',
    data() {
        return {
            data:[]
        }
    },
    methods: {
        async pullCompanies() {
            const models = await API.graphql({
                query:listCompaniess,
                variables:{
                    _deleted:false
                }
            });
            this.data = await models.data.listCompaniess.items.filter((item) => !item._deleted);
            console.log(models);
            
        },
        async createCompanies() {
            let random =Math.floor(Math.random() * 10);
            const models = await API.graphql({
                query:createCompanies,
                variables: { 
                    input:{
                        "title": "t_"+ random,
                        "alttitle":"alt_text"+random,
                        "source_id":""+random
                    }

                }
            });
            console.log(models);
            await this.pullCompanies();
        },
        async deleteCompanies(id) {
            console.log(id)
            const models = await API.graphql({
                query:deleteCompanies,
                variables: {
                    input:{
                        "id":id,
                        _version: 1
                        
                    },
                     
                }
            });
            console.log(models);
            await this.pullCompanies();

        }
    }
}
</script>